var undoClosedButt = {
  populateUndoSubmenu: function(aNode) {
    // remove existing menu items
    while (aNode.hasChildNodes())
      aNode.removeChild(aNode.firstChild);

    // get closed-tabs from nsSessionStore
    var ss = Cc["@mozilla.org/browser/sessionstore;1"].
              getService(Ci.nsISessionStore);

    // return if no restorable tabs
    var noHistory = document.getElementById("bundle_undoclosedtabsbutton")
                      .getString("noHistory");
    if (ss.getClosedTabCount(window) == 0) {
      aNode.appendChild(document.createElement("menuitem"));
      aNode.firstChild.setAttribute("label", noHistory);
      aNode.firstChild.setAttribute("disabled", "true");
      return;
    }

    // populate menu
    var undoItems = eval("(" + ss.getClosedTabData(window) + ")");
    for(var i = 0; i < undoItems.length; i++) {
      var m = aNode.appendChild(document.createElement("menuitem"));
      m.setAttribute("class", "menuitem-iconic bookmark-item");
      m.setAttribute("label", undoItems[i].title);
      m.setAttribute("value", i);
      m.setAttribute("oncommand", "undoCloseTab(" + i + ");");
      var image = UCT_ss_getImage(undoItems[i].state.xultab);
      m.setAttribute("image", image);
    }

    aNode.appendChild(document.createElement("menuseparator"));

    var clearHistoryLabel = document.getElementById("bundle_undoclosedtabsbutton")
                              .getString("clearHistory");
    var mItem = aNode.appendChild(document.createElement("menuitem"));
    mItem.setAttribute("oncommand", "undoClosedButt.clearClosedTabsHistory()");
    mItem.setAttribute("label", clearHistoryLabel);
    mItem.tooltipText = mItem.label;

  },

  clearClosedTabsHistory: function() {
    try {
      var maxUndo = gPrefService.getIntPref("browser.sessionstore.max_tabs_undo");
    } catch(ex) {
      var maxUndo = 10;
      gPrefService.setIntPref("browser.sessionstore.max_tabs_undo", maxUndo);
    }
    //clear close tabs history
    gPrefService.setIntPref("browser.sessionstore.max_tabs_undo", 0);

    //restore maximum undo history pref
    gPrefService.setIntPref("browser.sessionstore.max_tabs_undo", maxUndo);


    // update button disabled on TabOpen & TabClose
    gBrowser.addEventListener("TabOpen",undoClosedButt.tabOpenClose,false);
    gBrowser.addEventListener("TabClose",undoClosedButt.tabOpenClose,false);
    gBrowser.addEventListener("TabOpen",undoClosedButt.tabbarOpenClose,false);
    gBrowser.addEventListener("TabClose",undoClosedButt.tabbarOpenClose,false);
    // 1 second after browser window load
    setTimeout("undoClosedButt.tabbarOpenClose()", 250);
    setTimeout("undoClosedButt.tabOpenClose()", 250); 

  },

  rightClickMenu: function(aNode, aEvent) {
    if(aEvent.button == 2) {
      var popup = document.getElementById("undoclosedtabsbutton-menu");
      var x = aNode.boxObject.x;
      var y = aNode.boxObject.y + aNode.boxObject.height;
      document.popupNode = aNode;
      popup.showPopup(aNode, x, y, "popup", null, null);
    }
  },

  restartFX: function() {
    var appStartup = Components.classes["@mozilla.org/toolkit/app-startup;1"]
                               .getService(Components.interfaces.nsIAppStartup);
    appStartup.quit(appStartup.eForceQuit | appStartup.eRestart);  
  },

  //Disable the toolbar button
  tabOpenClose: function() {
    var ss = Components.classes["@mozilla.org/browser/sessionstore;1"].
                                 getService(Components.interfaces.nsISessionStore);
    var button = document.getElementById("undoclosedtabsbutton-toolbar-button") ;
    var count = ss.getClosedTabCount(window);
    // has closed tabs
    if (button && count>0)
       button.removeAttribute('disabled');
    // no closed tabs
    else if (button && count<1)
       button.setAttribute("disabled", "true");
  },

  //Disable the tabbar button
  tabbarOpenClose: function() {
    var ss = Components.classes["@mozilla.org/browser/sessionstore;1"].
                                 getService(Components.interfaces.nsISessionStore);
    var tabcontainer = document.getAnonymousElementByAttribute(gBrowser, "anonid", "tabcontainer");
    var tabbarbutton = document.getAnonymousElementByAttribute(tabcontainer, "class", "uctb-tab-button");
    var count = ss.getClosedTabCount(window);
    // has closed tabs
    if (tabcontainer, tabbarbutton && count>0)
       tabbarbutton.removeAttribute('disabled');
    // no closed tabs
    else if (tabcontainer, tabbarbutton && count<1)
       tabbarbutton.setAttribute("disabled", "true");
  }

}

window.addEventListener("load", UCT_init, false);
function UCT_init() {
   document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", onUCTBPopup, false);

   // Add attribute to nsSessionStore persistTabAttribute after delay
   // we call this after nsSessionStore.init
   window.setTimeout(UCT_ss_persist, 2000, false);

   // don't continue if Tabmix is installed
   if ("TMP_SessionStore" in window)
      return;

   // patch for bug 352524 [SessionStore] Exception when History menu 
   // clicked while SessionStore disabled
   eval("HistoryMenu.toggleRecentlyClosedTabs ="+HistoryMenu.toggleRecentlyClosedTabs.toString().replace(
      'var undoPopup = document.getElementById("historyUndoPopup");',
      '$& \
       document.getElementById("historyUndoMenu").setAttribute("hidden", !window.__SSi); \
       document.getElementById("endUndoSeparator").setAttribute("hidden", !window.__SSi); \
       if (!window.__SSi) return;'
   ));

   // add tab image and url in statustext to closed tab list
   // add menu entry to clear the closed tabs list
   eval("HistoryMenu.populateUndoSubmenu ="+HistoryMenu.populateUndoSubmenu.toString().replace(
      'var m = undoPopup.appendChild(document.createElement("menuitem"));',
      '$& \ m.setAttribute("class", "menuitem-iconic bookmark-item"); \
       var tabData = undoItems[i].state; \
       var activeIndex = (tabData.index || tabData.entries.length) - 1; \
       m.setAttribute("statustext", tabData.entries[activeIndex].url); \
       m.setAttribute("image", UCT_ss_getImage(tabData.xultab));'
   ).replace(
      'undoPopup.appendChild(document.createElement("menuseparator"));',
      '$& \ var clearHistoryLabel = document.getElementById("bundle_undoclosedtabsbutton").getString("clearHistory");\
       var mItem = undoPopup.appendChild(document.createElement("menuitem")); \
       mItem.setAttribute("oncommand", "undoClosedButt.clearClosedTabsHistory()"); \
       mItem.setAttribute("label", clearHistoryLabel);'
   ));

    // update button disabled on TabOpen & TabClose
    gBrowser.addEventListener("TabOpen",undoClosedButt.tabOpenClose,false);
    gBrowser.addEventListener("TabClose",undoClosedButt.tabOpenClose,false);
    gBrowser.addEventListener("TabOpen",undoClosedButt.tabbarOpenClose,false);
    gBrowser.addEventListener("TabClose",undoClosedButt.tabbarOpenClose,false);
    // 1 second after browser window load
    setTimeout("undoClosedButt.tabbarOpenClose()", 250);
    setTimeout("undoClosedButt.tabOpenClose()", 250); 

}

function UCT_ss_persist() {
   if (!window.__SSi) // nsISessionStore not initialized
     return;

   var ss = Cc["@mozilla.org/browser/sessionstore;1"].
         getService(Ci.nsISessionStore);
   ss.persistTabAttribute("image");
}

function UCT_ss_getImage(xultab) {
   var image;
   if (xultab) {
      xultab.split(" ").forEach(function(aAttr) {
         if (/^([^\s=]+)=(.*)/.test(aAttr) && RegExp.$1 == "image") {
            image = decodeURI(RegExp.$2);
         }
      });
   }
   return image || "";
}

function onUCTBPopup() {
  var someConditions = !(gContextMenu.isContentSelected ||
                          gContextMenu.onLink ||
                          gContextMenu.onImage ||
                          gContextMenu.onTextInput);

  gContextMenu.showItem("uctb-contextentry", someConditions);
  gContextMenu.showItem("uctb-separator", someConditions);
}

function canQuitApplication() {
  var os=Components.classes["@mozilla.org/observer-service;1"]
   .getService(Components.interfaces.nsIObserverService)
 if(!os)return true
   try{
  var cancelQuit=Components.classes["@mozilla.org/supports-PRBool;1"]
   .createInstance(Components.interfaces.nsISupportsPRBool)
   os.notifyObservers(cancelQuit,"quit-application-requested",null)
 if(cancelQuit.data)
   return false}
     catch(ex){}
     os.notifyObservers(null,"quit-application-granted",null)
   return true
}